package com.ruoyi.bst.dashboard.service;

import com.ruoyi.bst.dashboard.domain.vo.BriefVO;
import com.ruoyi.bst.order.domain.OrderQuery;
import com.ruoyi.bst.order.domain.enums.OrderStatus;
import com.ruoyi.bst.order.service.OrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.util.Arrays;
import java.util.List;

/**
 * @author wjh
 * 2024/12/26
 */
@Service
public class DashboardService {

    @Autowired
    private OrderService orderService;


    public BriefVO selectBrief() {
        BriefVO vo = new BriefVO();

        // 总订单数
        int total = orderService.selectCount(new OrderQuery());
        vo.setTotalOrderCount(total);

        // 本月起始到今日
        OrderQuery monthQuery = new OrderQuery();
        List<LocalDate> orderDateRange = Arrays.asList(LocalDate.now().withDayOfMonth(1), LocalDate.now());
        monthQuery.setOrderDateRange(orderDateRange);
        int monthCount = orderService.selectCount(monthQuery);
        vo.setMonthOrderCount(monthCount);

        // 待完成的订单数
        OrderQuery releasedQuery = new OrderQuery();
        releasedQuery.setStatus(OrderStatus.RELEASED.getStatus());
        int releasedCount = orderService.selectCount(releasedQuery);
        vo.setReleasedOrderCount(releasedCount);

        return vo;
    }
}
