package com.ruoyi.bst.logImport.domain.enums;

import com.ruoyi.bst.logImportDetail.domain.interfaces.ImportContent;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 导入日志业务类型
 * @author wjh
 * 2024/11/7
 */
@Getter
@AllArgsConstructor
public enum LogImportBizType {
    USER("1","用户", null);

    private final String type;
    private final String msg;
    private final Class<? extends ImportContent> contentClazz;  // 导出的类型

    public static LogImportBizType parse(String bizType) {
        for (LogImportBizType value : LogImportBizType.values()) {
            if (value.getType().equals(bizType)) {
                return value;
            }
        }
        return null;
    }
}
