package com.ruoyi.bst.order.domain;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.math.BigDecimal;
import java.time.LocalDate;

/**
 * 生产订单对象 bst_order
 *
 * @author ruoyi
 * @date 2024-12-16
 */
@Data
public class Order extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @Excel(name = "订单号")
    @ApiModelProperty("订单号")
    private String orderNo;

    @Excel(name = "主图")
    @ApiModelProperty("主图")
    private String picture;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "交货日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty("交货日期")
    private LocalDate deliveryDate;

    @Excel(name = "数量")
    @ApiModelProperty("数量")
    @NotNull(message = "数量不能为空")
    @Min(value = 1, message = "数量不能小于1")
    private BigDecimal num;

    @Excel(name = "客户")
    @ApiModelProperty("客户")
    @Size(max = 50, message = "客户长度不能超过50个字符")
    private String customer;

    @Excel(name = "订单状态", readConverterExp = "1=拟定,2=已发布,3=完工")
    @ApiModelProperty("订单状态")
    private String status;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "订单日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty("订单日期")
    private LocalDate orderDate;

    @Excel(name = "用料")
    @ApiModelProperty("用料")
    @Size(max = 200, message = "用料长度不能超过200个字符")
    private String material;
}
