package com.ruoyi.bst.order.service;

import com.ruoyi.bst.order.domain.Order;
import com.ruoyi.bst.order.domain.OrderBO;
import com.ruoyi.bst.order.domain.OrderQuery;
import com.ruoyi.bst.order.domain.OrderVO;

import java.util.List;

/**
 * 生产订单Service接口
 *
 * @author ruoyi
 * @date 2024-12-16
 */
public interface OrderService
{
    /**
     * 查询生产订单
     *
     * @param id 生产订单主键
     * @return 生产订单
     */
    public OrderVO selectOrderById(Long id);

    /**
     * 查询生产订单列表
     *
     * @param order 生产订单
     * @return 生产订单集合
     */
    public List<OrderVO> selectOrderList(OrderQuery order);

    /**
     * 新增生产订单
     *
     * @param order 生产订单
     * @return 结果
     */
    public int insertOrder(Order order);

    /**
     * 修改生产订单
     *
     * @param order 生产订单
     * @return 结果
     */
    public int updateOrder(Order order);

    /**
     * 批量删除生产订单
     *
     * @param ids 需要删除的生产订单主键集合
     * @return 结果
     */
    public int deleteOrderByIds(Long[] ids);

    /**
     * 删除生产订单信息
     *
     * @param id 生产订单主键
     * @return 结果
     */
    public int deleteOrderById(Long id);

    /**
     * 新增
     */
    int addOrder(OrderBO order);

    /**
     * 修改
     */
    int editOrder(OrderBO order);

    /**
     * 逻辑删除
     */
    int logicDel(Long id);

    /**
     * 完成订单
     */
    int finish(Long id);

    /**
     * 查询数量
     */
    int selectCount(OrderQuery query);
}
