package com.ruoyi.bst.order.service.impl;

import com.ruoyi.bst.order.domain.OrderBO;
import com.ruoyi.bst.order.domain.enums.OrderStatus;
import com.ruoyi.bst.order.service.OrderConverter;
import com.ruoyi.bst.order.service.OrderService;
import com.ruoyi.bst.orderProd.service.OrderProdConverter;
import com.ruoyi.common.core.domain.entity.SysUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author wjh
 * 2024/12/17
 */
@Service
public class OrderConverterImpl implements OrderConverter {

    @Autowired
    private OrderProdConverter orderProdConverter;

    @Autowired
    private OrderService orderService;


    /**
     * 新增时转为BO
     *
     * @param data
     * @param submit
     * @param user
     * @return
     */
    @Override
    public OrderBO toBOByCreate(OrderBO data, boolean submit, SysUser user) {
        if (data == null) {
            return null;
        }

        OrderBO bo = new OrderBO();
        bo.setPicture(data.getPicture());
        bo.setDeliveryDate(data.getDeliveryDate());
        bo.setNum(data.getNum());
        bo.setCustomer(data.getCustomer());
        bo.setCreateBy(user.getNickName());
        bo.setRemark(data.getRemark());
        bo.setOrderNo(data.getOrderNo());
        bo.setOrderDate(data.getOrderDate());
        bo.setMaterial(data.getMaterial());
        if (submit) {
            bo.setStatus(OrderStatus.RELEASED.getStatus());
        } else {
            bo.setStatus(OrderStatus.PROPOSED.getStatus());
        }
        bo.setProdList(orderProdConverter.toBOListByCreate(data.getProdList()));

        return bo;
    }

    @Override
    public OrderBO toBOByUpdate(OrderBO data, Boolean submit, SysUser user) {
        if (data == null) {
            return null;
        }

        OrderBO bo = new OrderBO();
        bo.setId(data.getId());
        bo.setPicture(data.getPicture());
        bo.setDeliveryDate(data.getDeliveryDate());
        bo.setNum(data.getNum());
        bo.setCustomer(data.getCustomer());
        bo.setRemark(data.getRemark());
        bo.setOrderNo(data.getOrderNo());
        bo.setOrderDate(data.getOrderDate());
        bo.setMaterial(data.getMaterial());
        if (submit) {
            bo.setStatus(OrderStatus.RELEASED.getStatus());
        }
        bo.setProdList(orderProdConverter.toBOListByUpdate(data.getProdList()));
        bo.setOld(orderService.selectOrderById(data.getId()));

        return bo;
    }
}
