package com.ruoyi.bst.orderProd.mapper;

import com.ruoyi.bst.orderProd.domain.OrderProd;
import com.ruoyi.bst.orderProd.domain.OrderProdQuery;
import com.ruoyi.bst.orderProd.domain.OrderProdVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 订单产品Mapper接口
 *
 * @author ruoyi
 * @date 2024-12-17
 */
public interface OrderProdMapper
{
    /**
     * 查询订单产品
     *
     * @param id 订单产品主键
     * @return 订单产品
     */
    public OrderProdVO selectOrderProdById(Long id);

    /**
     * 查询订单产品列表
     *
     * @param query 订单产品
     * @return 订单产品集合
     */
    public List<OrderProdVO> selectOrderProdList(@Param("query")OrderProdQuery query);

    /**
     * 新增订单产品
     *
     * @param orderProd 订单产品
     * @return 结果
     */
    public int insertOrderProd(OrderProd orderProd);

    /**
     * 修改订单产品
     *
     * @param orderProd 订单产品
     * @return 结果
     */
    public int updateOrderProd(@Param("data") OrderProd orderProd);

    /**
     * 删除订单产品
     *
     * @param id 订单产品主键
     * @return 结果
     */
    public int deleteOrderProdById(Long id);

    /**
     * 批量删除订单产品
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteOrderProdByIds(Long[] ids);

    /**
     * 批量插入
     */
    int batchInsert(@Param("list") List<? extends OrderProd> list);

    /**
     * 批量更新
     */
    int batchUpdate(@Param("list") List<? extends OrderProd> list);

    /**
     * 逻辑删除
     */
    int logicDel(@Param("ids") List<Long> ids);

    int logicDelByOrderId(@Param("orderId") Long orderId);
}
