package com.ruoyi.bst.prodProcess.domain;

import com.ruoyi.common.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * @author wjh
 * 2024/12/17
 */
@Data
public class ProdProcessVO extends ProdProcess{

    @ApiModelProperty("订单ID")
    private Long orderId;

    @ApiModelProperty("订单编号")
    private String orderNo;

    @ApiModelProperty("订单状态")
    private String orderStatus;

    @ApiModelProperty("订单图片")
    private String orderPicture;

    @ApiModelProperty("订单日期")
    private LocalDate orderDate;

    @ApiModelProperty("客户")
    private String orderCustomer;

    @ApiModelProperty("交货日期")
    private LocalDate orderDeliveryDate;

    @ApiModelProperty("用料")
    private String orderMaterial;

    @ApiModelProperty("特殊要求")
    private String orderRemark;

    @ApiModelProperty("订单创建人")
    private String orderCreateBy;

    @ApiModelProperty("订单创建时间")
    private LocalDateTime orderCreateTime;

    @ApiModelProperty("订单数量")
    private BigDecimal orderNum;

    @ApiModelProperty("生产车间名称")
    private String deptName;

    @ApiModelProperty("订单产品名称")
    private String orderProdName;

    @ApiModelProperty("产品图片")
    private String orderProdPicture;

    @ApiModelProperty("总上报数")
    private BigDecimal reportNum;

    @ApiModelProperty("有效清点数")
    private BigDecimal storeNum;

    @ApiModelProperty("产品规格")
    private String orderProdSpec;

    @ApiModelProperty("产品物料编码")
    private String orderProdMaterialNo;

    @ApiModelProperty("产品备注")
    private String orderProdRemark;

    @Excel(name = "处理方式")
    @ApiModelProperty("处理方式")
    private String handleWay;

    @Excel(name = "效果")
    @ApiModelProperty("效果")
    private String effect;

    @Excel(name = "颜色")
    @ApiModelProperty("颜色")
    private String color;

    @Excel(name = "盖子颜色")
    @ApiModelProperty("盖子颜色")
    private String coverColor;



    @ApiModelProperty("进度")
    public BigDecimal getProgress() {
        if (this.storeNum == null || this.getNum() == null) {
            return BigDecimal.ZERO;
        }
        return this.storeNum
                .multiply(new BigDecimal(100))
                .divide(this.getNum(), 2, RoundingMode.HALF_UP);
    }

}
